//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3C18CB4B006D.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3C18CB4B006D.cm

//## begin module%3C18CB4B006D.cp preserve=no
//## end module%3C18CB4B006D.cp

//## Module: ComponentInfo%3C18CB4B006D; Package specification
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/FunctionUtils/ComponentInfo.h

#ifndef COMPONENTINFO_H
#define COMPONENTINFO_H 1

//## begin module%3C18CB4B006D.additionalIncludes preserve=no
//## end module%3C18CB4B006D.additionalIncludes

//## begin module%3C18CB4B006D.includes preserve=yes
#include "xsTypes.h"
//## end module%3C18CB4B006D.includes

//## begin module%3C18CB4B006D.declarations preserve=no
//## end module%3C18CB4B006D.declarations

//## begin module%3C18CB4B006D.additionalDeclarations preserve=yes
//## end module%3C18CB4B006D.additionalDeclarations


//## Class: ComponentInfo%3AE4306A0082
//## Category: XSUtil::FunctionUtils%48DBD01C0111
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Persistence: Transient
//## Cardinality/Multiplicity: n



struct ComponentInfo 
{
    //## Constructors (generated)
      ComponentInfo();

    //## Constructors (specified)
      //## Operation: ComponentInfo%3AE4555E0290
      ComponentInfo (const string& componentName, const string& dataFile, size_t loc, const string& componentType, bool errorFlag, string addString, bool isStandard);


    //## Other Operations (specified)
      //## Operation: reset%3AE4972802FA
      void reset ();

    // Data Members for Class Attributes

      //## Attribute: name%3AE430CB015C
      //## begin ComponentInfo::name%3AE430CB015C.attr preserve=no  public: string {U} componentName
      string name;
      //## end ComponentInfo::name%3AE430CB015C.attr

      //## Attribute: sourceFile%3AE430ED0232
      //## begin ComponentInfo::sourceFile%3AE430ED0232.attr preserve=no  public: string {U} dataFile
      string sourceFile;
      //## end ComponentInfo::sourceFile%3AE430ED0232.attr

      //## Attribute: location%3AE430FB016F
      //## begin ComponentInfo::location%3AE430FB016F.attr preserve=no  public: size_t {U} loc
      size_t location;
      //## end ComponentInfo::location%3AE430FB016F.attr

      //## Attribute: type%3AE431090134
      //## begin ComponentInfo::type%3AE431090134.attr preserve=no  public: string {U} componentType
      string type;
      //## end ComponentInfo::type%3AE431090134.attr

      //## Attribute: error%3E36D6F10039
      //	true if the model calculates errors.
      //## begin ComponentInfo::error%3E36D6F10039.attr preserve=no  public: bool {U} errorFlag
      bool error;
      //## end ComponentInfo::error%3E36D6F10039.attr

      //## Attribute: infoString%3E36D72E038A
      //	An additional information string that can be read from
      //	the
      //	"model.dat" file to supply anything that new model
      //	implementations might need.
      //
      //	Initial use might be a generic 'component that needs
      //	to read from a fits file' filename and directory
      //## begin ComponentInfo::infoString%3E36D72E038A.attr preserve=no  public: string {U} addString
      string infoString;
      //## end ComponentInfo::infoString%3E36D72E038A.attr

      //## Attribute: isStandardXspec%41758A260372
      //## begin ComponentInfo::isStandardXspec%41758A260372.attr preserve=no  public: bool {U} isStandard
      bool isStandardXspec;
      //## end ComponentInfo::isStandardXspec%41758A260372.attr

  public:
  protected:
  private:
  private: //## implementation
};

//## Class: NameCacheType%3AE43CF10076
//## Category: XSUtil::FunctionUtils%48DBD01C0111
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3C18CD9700C7;ComponentInfo { -> }

typedef std::multimap<string,ComponentInfo> NameCacheType;

// Class ComponentInfo 

//## begin module%3C18CB4B006D.epilog preserve=yes
//## end module%3C18CB4B006D.epilog


#endif
